//Application self Component Constructor
function GameWindow(scene_no) {
	
	var screenHeight = Ti.Platform.displayCaps.platformHeight;
	var screenWidth = Ti.Platform.displayCaps.platformWidth;
	var current_scene_no = 0;
	var total_placed_pieces = 0;
	var selected_piece=-1;
	var original_image;
	var scenes_map;
	var rankedPieces=[]; // contains pieces sorted from top most to bottom
	var pieces=[];
	var map;
	var game;
	var nextBtn;
	var loadingTxt;
	var touchMoveCounter=0;
	var oldTouchMoveCounter=-1;
	var timerId;
	var transform;
	
	var SCALE_FACTOR = 1;
	var MAP_WIDTH_RATIO = 0.5;
	var MAP_HEIGHT_RATIO =0.9;
	var PIECE_WIDTH_RATIO = 0.4;
	var PIECE_HEIGHT_RATIO = 0.9;
	var DISTANCE_CLOSE_THRESHHOLD = 20;  // PIXEL
	var MAP_WIDTH;
	var MAP_HEIGHT;
	
	
	function setScaleFactor(scene_no){
		var exactImg = quicktigame2d.createSprite({
			 image:'images/'+scene_no+'.png'
		});
		
		var xScale = (game.screen.width*MAP_WIDTH_RATIO)/exactImg.width;
		xScale = game.screen.width>480?1:xScale; 
		var yScale = ((game.screen.height-60)*MAP_HEIGHT_RATIO)/exactImg.height;
		yScale = game.screen.height>320?1:yScale;
		SCALE_FACTOR = xScale < yScale ? xScale : yScale;
		exactImg.dispose();
	}
	function getScenesMap(){
		var temp_scenes_map = {
				"scenes":[
				 { //A0
					"pieces":[{
						"x":3,
						"y":1
					},{
						"x":46,
						"y":56
					},{
						"x":141,
						"y":54
					},{
						"x":310,
						"y":118
					}]
				},
				{ //KA1
					"pieces":[{
						"x":2,
						"y":2
					},{
						"x":54,
						"y":49
					},{
						"x":144,
						"y":190
					},{
						"x":229,
						"y":55
					}]
				},
				{ //PA2
					"pieces":[{
						"x":62,
						"y":56
					},{
						"x":108,
						"y":129
					},{
						"x":187,
						"y":66
					},{
						"x":243,
						"y":3
					}]
				},
				{ //THA3
					"pieces":[{
						"x":65,
						"y":45
					},{
						"x":77,
						"y":135
					},{
						"x":187,
						"y":0
					}]
				},
				{ //U4
					"pieces":[{
						"x":4,
						"y":2
					},{
						"x":51,
						"y":171
					},{
						"x":141,
						"y":170
					}]
				},
				{ //UU5
					"pieces":[{
						"x":4,
						"y":2
					},{
						"x":52,
						"y":173
					},{
						"x":174,
						"y":169
					}]
				},
				{ //LA6
					"pieces":[{
						"x":43,
						"y":3
					},{
						"x":90,
						"y":64
					},{
						"x":228,
						"y":47
					}]
				},
				{ //AAA7
					"pieces":[{
						"x":106,
						"y":2
					},{
						"x":254,
						"y":95
					},{
						"x":3,
						"y":97
					}]
				},
				{ //SHA8
					"pieces":[{
						"x":98,
						"y":52
					},{
						"x":221,
						"y":52
					},{
						"x":317,
						"y":7
					}]
				},
				{ //MA9
					"pieces":[{
						"x":67,
						"y":4
					},{
						"x":144,
						"y":96
					},{
						"x":256,
						"y":4
					},{
						"x":283,
						"y":157
					}]
				}]
			};
		return temp_scenes_map;
	}
	scenes_map = getScenesMap();
	
	
	
	function isDistanceClose(x1,y1,x2,y2,T){
		var d = Math.sqrt(((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)));
		return parseInt(d)<T;
	}
	
	var self = Ti.UI.createView({
		backgroundColor:'white',
		layout:'composite'
		});

	// Obtain game module
	var quicktigame2d = require('com.googlecode.quicktigame2d');
	// Create view for your game.
	// Note that game.screen.width and height are not yet set until the game is loaded
	game = quicktigame2d.createGameView();
//	transform  = quicktigame2d.createTransform();
	// Frame rate can be changed (fps can not be changed after the game is loaded)
	game.fps =15;
	
	//game.opaque = true;
	

		function createNewScene(scene_no) {

		scenes_map = getScenesMap();
		if (scene_no >= scenes_map.scenes.length){
			scene_no = 0;
			//self.fireEvent('hidePrevBtn',{});
		}
		
		if(scene_no == 0){
			self.fireEvent('hidePrevBtn',{});
		}
		else{
			self.fireEvent('showPrevBtn',{});
		}
		
		setScaleFactor(scene_no);
		current_scene_no = scene_no;
		total_placed_pieces = 0;

		// Create game scene
		var scene = quicktigame2d.createScene();
		// alert('ci'+current_scene_no);
		function createPieces() {

			scenes_map = getScenesMap();
			pieces = [];
			rankedPieces = [];

			if (current_scene_no > scenes_map.scenes.length)
				current_scene_no = 0;

			// create pieces and place them in scene
			for ( var i = 0; i < scenes_map.scenes[current_scene_no].pieces.length; i++) {
				var xPos = 10;
				var yPos = map.y;
				var piece_no = i + 1;
				pieces[i] = quicktigame2d.createSprite({
					image : 'images/' + scene_no + '_' + i + '.png',
					x : xPos,
					y : yPos,
					placed : false
				});
				var pieceNo = i + 1;
				pieces[i].width = pieces[i].width * SCALE_FACTOR;
				pieces[i].height = pieces[i].height * SCALE_FACTOR;

				pieces[i].z = scenes_map.scenes[scene_no].pieces.length - i; // give
																				// initial
																				// Z
																				// ranking

				rankedPieces.push(i);
				scene.add(pieces[i]);
			}
		}
		var bg = quicktigame2d.createSprite({
			image : 'images/' + 'bg' + '.jpg',
			x : 0,
			y : 0,
			height : game.screen.height,
			width : game.screen.width
		});
		var mapXpos = (game.screen.width * PIECE_WIDTH_RATIO);
		map = quicktigame2d.createSprite({
			image : 'images/' + scene_no + '.png',
			y : 60,
			x : mapXpos
		});

		map.z = 0;
		map.width = map.width * SCALE_FACTOR;
		map.height = map.height * SCALE_FACTOR;

		createPieces(); // create pieces

		scene.add(bg);
		scene.add(map);
		game.popScene();
		// add your scene to game view
		game.pushScene(scene);
		game.startCurrentScene();
	}
	
	//touch events for pieces
	game.addEventListener('touchstart',function(e){
		// Ti.API.info(e.type + ": source: "+e.source+": " + JSON.stringify(e.points));
		var nothing_selected = true;
		 for(var i in rankedPieces){
			 if(!pieces[rankedPieces[i]].placed && pieces[rankedPieces[i]].contains(e.x,e.y)){
				 Titanium.Media.vibrate([0,100]);
				 //pieces[rankedPieces[i]].x = e.x;
				 //pieces[rankedPieces[i]].y = e.y;
				 try{
					 var file = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory, 'audio/' + 'select' + '.wav');
				 var player = Ti.Media.createSound({url:file.nativePath});
				   player.play();
				}catch(e){
					//alert(e);
				}
				nothing_selected=false;
				// Ti.API.info("currently selected piece is: "+rankedPieces[i]);
			
				 var temp = rankedPieces[i];
				 selected_piece = temp;
				 rankedPieces.splice(i,1);			//remove piece from previous position
				 rankedPieces.unshift(temp);  // place the piece in top most position
				 for(j in rankedPieces){
					 pieces[rankedPieces[j]].z = scenes_map.scenes[current_scene_no].pieces.length-j;
				 }
				 
				 pieces[selected_piece].xDif = e.x-pieces[selected_piece].x;
				 pieces[selected_piece].yDif = e.y-pieces[selected_piece].y;
				
				 break;

			 }
		 }
		
		 if(nothing_selected){
			 selected_piece = -1;
		 }
	});
	
	//createNewScene(0);
	
	game.addEventListener('touchend',function(e){	
		//clearInterval(timerId);
	});
	game.addEventListener('touchmove',function(e){	
		//Ti.API.info(e.type + ": source: "+e.source+": " + JSON.stringify(e.points));
		
		 if(selected_piece>-1 && !pieces[selected_piece].placed){
			 var xDif = pieces[selected_piece].xDif,
			 	yDif = pieces[selected_piece].yDif;
			 if(e.x-xDif>0 && e.y-yDif>0 && e.x-xDif+pieces[selected_piece].width<game.screen.width && e.y-yDif+pieces[selected_piece].height<game.screen.height){
				 pieces[selected_piece].x=e.x-xDif;
				 pieces[selected_piece].y=e.y-yDif;
				 
//				 transform.duration = 0.5;
//				 transform.x = e.x-xDif;
//				 transform.y = e.y-yDif;
//				 pieces[selected_piece].transform(transform);
			 var x1=(scenes_map.scenes[current_scene_no].pieces[selected_piece].x*SCALE_FACTOR)+map.x,
		 	 y1=(scenes_map.scenes[current_scene_no].pieces[selected_piece].y*SCALE_FACTOR)+map.y,
		 	 x2 = pieces[selected_piece].x,
		 	 y2 = pieces[selected_piece].y;
		 if(isDistanceClose(x1, y1, x2, y2, DISTANCE_CLOSE_THRESHHOLD)){
			 total_placed_pieces++;
			 pieces[selected_piece].placed = true;
			 pieces[selected_piece].z=1;
			 pieces[selected_piece].move(x1,y1);
			 try{
				 var file = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory, 'audio/' + 'fit' + '.wav');
				 var player = Ti.Media.createSound({url:file.nativePath});
				   player.play();
			}catch(e){
				//alert(e);
			}
			 rankedPieces.splice(0,1);
			 if(total_placed_pieces==scenes_map.scenes[current_scene_no].pieces.length){				
				 
				 /*var imgXpos=(game.screen.width*PIECE_WIDTH_RATIO);
				 original_image = quicktigame2d.createSprite({
						image:'images/'+current_scene_no+'_final.png',
						x:imgXpos,
						y:60
					});*/
				 /*var sceneSummaryImg =quicktigame2d.createSprite({
						image:'images/'+current_scene_no+'_summary.png',
						x:10,y:10
					});*/				
							
				 var bg = quicktigame2d.createSprite({
					 image:'images/'+current_scene_no+'_bg'+'.jpg',
					 x:0,y:0,
					 height:game.screen.height, width:game.screen.width
					});				 
				 
				 /*var gif = quicktigame2d.createSprite({
					 image:'loading.gif',
					 x:parseInt(game.screen.width/2),
					 y:parseInt(game.screen.height/2),
					 height:48,
					 width:48
					});*/	
				 
				 var scene = quicktigame2d.createScene();
				 /*original_image.width = original_image.width*SCALE_FACTOR;
				 original_image.height = original_image.height*SCALE_FACTOR;*/				
				 
				 scene.add(bg);
				 //scene.add(gif);
				 //scene.add(original_image);
			 
				 //scene.add(sceneSummaryImg);
				
				 //game.popScene();
					// add your scene to game view
				 var texture_to_unload=current_scene_no-1;
				 
				 game.unloadTexture('images/'+texture_to_unload+'_bg'+'.jpg');
				 game.unloadTexture('images/' +texture_to_unload + '.png');
				 game.unloadTexture('images/bg.jpg');
				 
				// show ad
				 self.fireEvent('showad',{});
				 
				 game.replaceScene(scene);
				 game.startCurrentScene();				 
				 		 
				 setTimeout(function(){
					 try{
						 var file = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory, 'audio/' + 'clap' + '.mp3');
						 var player = Ti.Media.createSound({url:file.nativePath});
						   player.play();
					}catch(e){
						//alert(e);
					}
				 },500);
				 
				 //current_scene_no++;
				 
			 }
		 }
		 }
		 }
		
	});
	game.addEventListener('onloadsprite', function(e) {
		loadingTxt.hide();
		
	});
	// Onload event is called when the game is loaded.
	// The game.screen.width and game.screen.height are not yet set until this onload event.
	game.addEventListener('onload', function(e) {
	    // Your game screen size is set here if you did not specifiy game width and height using screen property.
	    // Note: game.size.width and height may be changed due to the parent layout so check them here.
	    Ti.API.info("view size: " + game.size.width + "x" + game.size.height);
	    Ti.API.info("game screen size: " + game.screen.width/2);
	    createNewScene(scene_no);	    
	    //nextBtn.setTop(game.screen.height/2 - 10);
	    //prevBtn.setTop(game.screen.height/2 - 10);
	    
	    // Start the game	    
	    game.start();
	});
	
	nextBtn = Ti.UI.createButton({
		 backgroundImage:'../../../images/next.png',
		 right:5,
		 bottom:5,
		 width:'10%',
		 height:'13%',
		 backgroundSelectedImage:'../../../images/next-select.png'
	 });
	 nextBtn.addEventListener('click',function(e){
		 scenes_map = getScenesMap();
		 current_scene_no++;
		 self.fireEvent('removead',{});
		 createNewScene(current_scene_no);
		 
		 /*if(current_scene_no < scenes_map.scenes.length){
			 prevBtn.show();
		 }*/
	 });
	 
	 prevBtn = Ti.UI.createButton({
		 backgroundImage:'../../../images/prev.png',
		 left:5,
		 bottom:5,
		 width:'10%',
		 height:'13%',
		 backgroundSelectedImage:'../../../images/prev-select.png'
	 });
	 prevBtn.addEventListener('click',function(e){
		 scenes_map = getScenesMap();
		 current_scene_no--;		 
		 createNewScene(current_scene_no);
		 
		 if(current_scene_no == 0){
			 this.hide();
		 }
	 });
	 
	 
	 /*homeBtn = Ti.UI.createButton({
		 backgroundImage:'../../../images/home.png',
		 left:'',
		 top:5,
		 width:20,
		 height:16
	 });
	 homeBtn.addEventListener('click',function(e){
		 self.fireEvent('returntohome',{});
	 });*/
	 
	 loadingTxt = Ti.UI.createLabel({
		 text:'Loading...',
		 height:20,
		 color:'white',
		 center:{
			 x:game.screen.width/2,
			 y:game.screen.height/2
		 }
	 });
	 
	 self.addEventListener('hidePrevBtn',function(e){
		 prevBtn.hide();
	 });
	 
	 self.addEventListener('showPrevBtn',function(e){
		 prevBtn.show();
	 });
	
	// Add your game view
	self.add(game);
	self.add(nextBtn);
	//self.add(homeBtn);
	self.add(prevBtn);
	self.add(loadingTxt);
	
	/*if(scene_no == 0){
		Ti.API.info('hideprev');
		prevBtn.hide();
	}*/
	
	return self;
}

//make constructor function the public component interface
module.exports = GameWindow;
